# Génération de setup

La procédure de publication pour Git, elle est disponible via [ce lien](http://documentation-dev.veremes.net/dev/fr/git/basics.html#processus-de-sortie-de-version-d-application)

## Génération d'un setup d'installation pour une application

Il faut passer par [le serveur Jenkins de Veremes](http://jenkins.veremes.net/), et lancer le job **Generate_app_setup_2020**.

Il faut définir l'application à générer (si l'application que vous voulez générer n'est pas dans la liste il faut demander à un administrateur Jenkins de l'ajouter).
La référence du commit Git de l'application à générer, la référence du commit pour Le job jenkins et la référence Git pour VAI.

La référence du commit pour Jenkins, est utilisé pour la définition du pipeline et l'AMI  à utilisé pour lancer VAI.
La référence du commit pour VAI, permet de définir quelle version de VAI on veut lancer pour générer l'installer
La référence du commit de l'application est utilisé pour généré le app.tgz.

Quand je parle de référence de commit je fais référence, à une branche, un tag ou un sha1.

Jenkins va alors lancer un EC2 d'aprés une AMI Linux avec PyInstaller, et les autres librairies déjà installées. Jenkins, va ensuite se connecter à la machine, cloner les sources de l'application à générer, puis lancer un script qui va permettre la construction du app.tgz. 
Ce script va d'abord cloner les modules, lancer le script mount_project.sh, installer les dépendances du frontend et le compiler en mode production, puis installer les dépendances pour le backend.
Il va ensuite télécharger les ressources externes et nettoyer l'arboresence. Pour finir on produit une archive qui va conserver l'arborescence des points de montage comme si c'était des dossiers normaux.

```{Warning}
  VAI peut compiler les moteurs pour vous si le script build_engine.sh est présent cependant je vous le déconseille. La compilation via nexe avec wine présente de gros problèmes de fonctionnement ensuite sur la version Windows. Il vaut mieux les compiler en amont avec l'autre job jenkins prévu pour et les ajouter comme ressources complémentaires.
```

Ensuite on lance la production du binaire `installer`, une première fois pour linux sur la machine directement et une seconde fois sur la même machine à travers Wine ce qui permet d'avoir la version Windows du binaire.

Une fois cette étape terminée, Jenkins zip les setups et les transferts sur AWS S3 dans le dossier **builds** du bucket **veremes-dev-ressource**.

## Génération d'un setup d'installation pour un module externe

Il est aussi possible de générer un setup permettant d'installer un module complémentaire dans une application existante (comme Oxalis ou RisMajic).
Au niveau de l'utilisation c'est sensiblement la même chose il faut lancer le job **Generate_mod_setup_2020**.

La construction du fichier `mod.tgz` est bien plus rapide vu qu'il n'y a pas de compilation ou de récupération de dépendances supplémentaires.
La compilation de l'installer est identique. 
L'archive finale est également générée et envoyée sur AWS S3.